<template lang="pug">
	section.search-results
		div(v-if="haveResults"): MovieList(:movies="movies")
		div(v-else-if="pendingResults"): div.loading-wrapper
			div: MoonLoader(color="#96b5b4", size="100px")
			p Searching...
		div(v-else): p No results found!
</template>

<script>
	import { allTrue } from '@gabegabegabe/utils/dist/array/reducers';
	import { fetchMovies } from '~/modules/rt';
	import { Movie } from '~/classes/Movie';

	const MoonLoader = async () => await import('vue-spinner/src/MoonLoader');
	const MovieList = async () => await import('~/views/MovieList');

	export default {
		name: 'SearchResults',
		components: { MoonLoader, MovieList },
		data () {
			return {
				pendingResults: false
			};
		},
		computed: {
			haveResults () { return !this.pendingResults && this.movies.length > 0; },
			movies: {
				get () { return this.$store.state.searchResults; },
				set (val) { this.$store.commit('setSearchResults', val); }
			},
			terms () { return this.$route.params.terms; }
		},
		watch: {
			terms (newVal, oldVal) {
				if (newVal !== oldVal) this.populateResults();
			}
		},
		mounted () {
			const { $store: { getters: { searchResultsNeedRefresh } } } = this;
			if (!this.haveResults || searchResultsNeedRefresh) this.populateResults();
		},
		methods: {
			async populateResults () {
				this.pendingResults = true;
				const movies = await fetchMovies(this.terms);

				if (movies.map(movie => movie instanceof Movie).reduce(allTrue)) this.movies = movies;
				this.pendingResults = false;
			}
		}
	};
</script>

<style lang="scss" scoped>
	div.v-spinner {
		display: flex;
		justify-content: center;
		padding: 2rem;
	}

	p {
		text-align: center;
		font-size: 1.25rem;
		line-height: 1.6em;
	}
</style>
